package cpcns.dingZhi.zongZhuanKu.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.zongZhuanKu.dao.IZongZhuanKuDao;
import cpcns.dingZhi.zongZhuanKu.service.IZongZhuanKuService;
import cpcns.utils.CommStatic;
import cpcns.utils.DateUtil;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("zongZhuanKuService")
public class ZongZhuanKuServiceImpl extends DangAnBaseServiceImpl<T> implements IZongZhuanKuService {
  @Autowired
  private IZongZhuanKuDao zongZhuanKuDao;
  
  private Integer batchSize = Integer.valueOf(1000);
  
  private Integer count = Integer.valueOf(1);
  
  private Integer wjcount = Integer.valueOf(1);
  
  private Integer fjcount = Integer.valueOf(1);
  
  private static String dataType;
  
  private String table;
  
  private Integer hbs = Integer.valueOf(1);
  
  private Integer wjhbs = Integer.valueOf(1);
  
  private Integer fjhbs = Integer.valueOf(1);
  
  private String leiXing;
  
  private String menLei;
  
  private long tiqupici = 0L;
  
  private List lsit = new ArrayList();
  
  private List wjlsit = new ArrayList();
  
  private List fjlsit = new ArrayList();
  
  private Connection bdkconn;
  
  public String getDataType() {
    return dataType;
  }
  
  public long getTiqupici() {
    return this.tiqupici;
  }
  
  public void setTiqupici(long tiqupici) {
    this.tiqupici = tiqupici;
  }
  
  public Integer getHbs() {
    return this.hbs;
  }
  
  public void setHbs(Integer hbs) {
    this.hbs = hbs;
  }
  
  public Integer getWjhbs() {
    return this.wjhbs;
  }
  
  public void setWjhbs(Integer wjhbs) {
    this.wjhbs = wjhbs;
  }
  
  public Integer getFjhbs() {
    return this.fjhbs;
  }
  
  public void setFjhbs(Integer fjhbs) {
    this.fjhbs = fjhbs;
  }
  
  public String getTable() {
    return this.table;
  }
  
  public void setTable(String table) {
    this.table = table;
  }
  
  public void setDataType(String dataType) {
    cpcns.dingZhi.zongZhuanKu.service.impl.ZongZhuanKuServiceImpl.dataType = dataType;
  }
  
  public Integer getBatchSize() {
    return this.batchSize;
  }
  
  public Integer getWjcount() {
    return this.wjcount;
  }
  
  public void setWjcount(Integer wjcount) {
    this.wjcount = wjcount;
  }
  
  public Integer getFjcount() {
    return this.fjcount;
  }
  
  public void setFjcount(Integer fjcount) {
    this.fjcount = fjcount;
  }
  
  public void setBatchSize(int batchSize) {
    this.batchSize = Integer.valueOf(batchSize);
  }
  
  public int tiQu(JSONObject jsonObject) {
    int result = 0;
    try {
      this.count = Integer.valueOf(1);
      this.wjcount = Integer.valueOf(1);
      this.fjcount = Integer.valueOf(1);
      this.lsit = new ArrayList();
      this.wjlsit = new ArrayList();
      this.fjlsit = new ArrayList();
      this.table = jsonObject.getString("table");
      this.menLei = jsonObject.getString("menLei");
      String fileds = jsonObject.getString("filed");
      dataType = this.zongZhuanKuDao.getDataType();
      this.leiXing = jsonObject.getString("leiXing");
      String type = jsonObject.getString("type");
      Connection connection = null;
      String wjtable = CommStatic.getMenLeiToBiaoMing(this.menLei);
      if ("1".equals(this.leiXing)) {
        System.out.println("提取到========ZZK");
        connection = getShuJuYuan("ZZK");
      } else {
        System.out.println("移交进馆========ZSK");
        connection = getShuJuYuan("ZSK");
      } 
      String dWQuanZongHao = AppConfiguration.getConfigValue("CPCNS_QUANZHONGHAO");
      System.out.println("========获取正式库" + dWQuanZongHao);
      this.bdkconn = getShuJuYuan(dWQuanZongHao);
      System.out.println("========获取正式库");
      if (this.bdkconn != null && connection != null) {
        String sql_ = "select max(HANGBIAOSHI) HANGBIAOSHI from " + this.table;
        this.hbs = getHangBiaoShi(connection, sql_);
        String wjsql_ = "select max(HANGBIAOSHI) HANGBIAOSHI from " + wjtable;
        this.wjhbs = getHangBiaoShi(connection, wjsql_);
        String fjsql_ = "select max(HANGBIAOSHI) HANGBIAOSHI from " + wjtable + "FuJian";
        this.fjhbs = getHangBiaoShi(connection, fjsql_);
        PreparedStatement ps = connection.prepareStatement(formatSQL(fileds, 0, this.table));
        PreparedStatement wjps = connection.prepareStatement(formatSQL(fileds, 1, wjtable));
        PreparedStatement fjps = connection.prepareStatement(formatSQL(fileds, 2, wjtable));
        StringBuffer sql = (new StringBuffer("select * from ")).append(this.table).append(" where zhuangTai not in (3,4) ");
        sql.append(fenXiFiles(jsonObject));
        System.out.println("查询语句========" + sql);
        if (!"0".equals(type)) {
          System.out.println("========盒或卷开始");
          addHeOrAnJuan(fileds, sql.toString(), ps, wjps, fjps, wjtable);
          ps.executeBatch();
          wjps.executeBatch();
          fjps.executeBatch();
          ps.close();
          wjps.close();
          fjps.close();
          System.out.println("========盒或卷结束");
          String upsql = "update G_BIAOLIUSHUIHAO SET liushuihao=" + this.hbs + " where biaoming='" + this.table + "' or biaoming='" + this.table.toUpperCase() + "'";
          setUpdate(connection, upsql);
          if (this.lsit.size() > 0) {
            String _hbs = StringUtils.join(this.lsit.toArray(), ",");
            String del_upd = "Update " + this.table + " set zhuangTai=3 where zhuangTai not in (3,4) and hangbiaoshi in (";
            String wj_upd = "Update " + wjtable + " set zhuangTai=3 where zhuangTai not in (3,4) and guanlianbiaoshi in (";
            updateInfo(del_upd, _hbs, this.bdkconn);
            updateInfo(wj_upd, _hbs, this.bdkconn);
          } 
          this.lsit.clear();
        } else {
          System.out.println("========文件开始");
          StringBuffer countsql = (new StringBuffer("select count(*) num from ")).append(this.table).append(" where zhuangTai not in (3,4)");
          countsql.append(fenXiFiles(jsonObject));
          int counts = getCount(this.bdkconn, countsql.toString()).intValue();
          Integer num = Integer.valueOf(5000);
          Integer intPage = Integer.valueOf(1);
          Integer page = Integer.valueOf(counts / num.intValue());
          if (counts % num.intValue() != 0)
            page = Integer.valueOf(page.intValue() + 1); 
          for (int p = 0; p < page.intValue(); p++) {
            int startpage = p * num.intValue();
            int endpage = num.intValue() * (p + 1);
            StringBuffer allsql = new StringBuffer();
            if ("MYSQL".equals(dataType)) {
              allsql.append("SELECT A.* FROM ( ")
                .append(sql.toString()).append(" ) A limit ").append(startpage).append(" , ").append(endpage - 1);
            } else {
              allsql.append("SELECT * FROM ( SELECT A.*, ROWNUM RN FROM ( ")
                .append(sql.toString()).append(" ) A ) WHERE RN BETWEEN ").append(startpage).append(" and ").append(endpage - 1);
            } 
            List<Map<String, Object>> list = getListByMap(allsql.toString());
            addWenjian(fileds, "", list, wjps, fjps, Integer.valueOf(0), this.table);
            wjps.executeBatch();
            fjps.executeBatch();
            String in_hbs = StringUtils.join(this.wjlsit.toArray(), ",");
            String del_upd = "Update  " + wjtable + " set zhuangTai=3  where hangBiaoShi in (";
            updateInfo(del_upd, in_hbs, this.bdkconn);
            wjps.close();
            fjps.close();
            this.wjlsit.clear();
          } 
          System.out.println("========文件结束");
          this.wjlsit.clear();
          this.lsit.clear();
        } 
        System.out.println("========提取或移交进馆完成");
        String wjupsql = "update G_BIAOLIUSHUIHAO SET liushuihao=" + this.wjhbs + " where biaoming='" + wjtable + "' or biaoming='" + wjtable.toUpperCase() + "'";
        setUpdate(connection, wjupsql);
        String fjupsql = "update G_BIAOLIUSHUIHAO SET liushuihao=" + this.fjhbs + " where biaoming='" + wjtable + "FuJian' or biaoming='" + wjtable.toUpperCase() + "FUJIAN'";
        setUpdate(connection, fjupsql);
        System.out.println("========更新表流水号完成");
        fjps.close();
        wjps.close();
        if (connection != null)
          connection.close(); 
        if (this.bdkconn != null)
          this.bdkconn.close(); 
      } else {
        result = -1;
      } 
    } catch (Exception e) {
      result = 0;
      e.printStackTrace();
    } 
    return result;
  }
  
  private void updateInfo(String sql, String biaoshis, Connection con) {
    try {
      if (StringUtils.isNotBlank(biaoshis)) {
        String[] strs = biaoshis.split(",");
        int len = strs.length;
        int d = 500;
        int num = len / d;
        int rem = len % d;
        if (rem != 0)
          num++; 
        if (len < d) {
          String sql1 = String.valueOf(sql) + biaoshis + ")";
          setUpdate(con, sql1);
          sql1 = "";
        } else {
          String str = "";
          for (int i = 0; i < num; i++) {
            for (int j = 0; j < d; j++) {
              int gs = i * d + j;
              if (gs < len)
                if (str.equals("")) {
                  str = strs[gs];
                } else {
                  str = String.valueOf(str) + "," + strs[gs];
                }  
            } 
            String sql2 = String.valueOf(sql) + str + ")";
            setUpdate(con, sql2);
            str = "";
            sql2 = "";
          } 
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  private void setUpdate(Connection con, String sql) {
    try {
      System.out.println("sql========" + sql);
      Statement upsql = con.createStatement();
      upsql.executeUpdate(sql);
      upsql.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  private Integer getCount(Connection con, String sql) {
    Integer count = Integer.valueOf(0);
    try {
      Statement upsql = con.createStatement();
      System.out.println("sql========" + sql);
      ResultSet rs = upsql.executeQuery(sql);
      while (rs.next())
        count = Integer.valueOf(Integer.parseInt(rs.getString("NUM"))); 
      rs.close();
      upsql.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return count;
  }
  
  private static Integer getHangBiaoShi(Connection con, String sql) {
    Integer hangBiaoShi = Integer.valueOf(4);
    try {
      Statement hstat = con.createStatement();
      ResultSet hres = hstat.executeQuery(sql);
      while (hres.next()) {
        String hbs = hres.getString("hangBiaoShi");
        if (!"MYSQL".equals(dataType))
          hbs = hres.getString("HANGBIAOSHI"); 
        if (StringUtils.isNotBlank(hbs))
          hangBiaoShi = Integer.valueOf(Integer.valueOf(hbs).intValue() + 4); 
      } 
      hstat.close();
      hres.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return hangBiaoShi;
  }
  
  private static long getBanBenHao(Connection con, String sql) {
    long bbh = 0L;
    try {
      Statement hstat = con.createStatement();
      ResultSet hres = hstat.executeQuery(sql);
      while (hres.next()) {
        String bbh_ = hres.getString("banBenHao");
        if (!"MYSQL".equals(dataType))
          bbh_ = hres.getString("BANBENHAO"); 
        if (StringUtils.isNotBlank(bbh_))
          bbh = Long.parseLong(bbh_); 
      } 
      hstat.close();
      hres.close();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return bbh;
  }
  
  private void info(Map<String, Object> map, String fileds, PreparedStatement ps, Object newhbs, Integer lx, Integer hbs) {
    Map<String, Object> map_ = map;
    String[] strss = fileds.split(";");
    String[] strs = strss[lx.intValue()].split(",");
    int index = 1;
    try {
      for (int j = 0; j < strs.length; j++) {
        String str = strs[j];
        if (!"MYSQL".equals(dataType))
          str = strs[j].toUpperCase(); 
        if (str.endsWith("-data") || str.endsWith("-DATA")) {
          String str_ = str.replaceAll("-data", "").replaceAll("-DATA", "");
          Object va = map_.get(str_);
          if (va != null) {
            ps.setDate(index, DateUtil.strToDate((String)va));
          } else {
            ps.setDate(index, (Date)null);
          } 
        } else if ("HANGBIAOSHI".equals(str)) {
          ps.setObject(index, hbs);
        } else if ("GUANLIANBIAOSHI".equals(str) && newhbs != "0") {
          ps.setObject(index, newhbs);
        } else {
          Object obj = map_.get(str);
          ps.setObject(index, obj);
        } 
        index++;
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  private void addHeOrAnJuan(String fileds, String sql, PreparedStatement heps, PreparedStatement wjps, PreparedStatement fjps, String wjtable) {
    try {
      System.out.println("========获取盒或卷记录==");
      List<Map<String, Object>> list = getListByMap(sql);
      if (list != null && list.size() > 0) {
        System.out.println("========获取盒或卷记录总数==" + list.size());
        for (int i = 0; i < list.size(); i++) {
          Map<String, Object> map = list.get(i);
          Object oldhbs = map.get("hangBiaoShi");
          if (!"MYSQL".equals(dataType))
            oldhbs = map.get("HANGBIAOSHI"); 
          this.lsit.add(oldhbs);
          int hbs_ = this.hbs.intValue();
          info(map, fileds, heps, Integer.valueOf(0), Integer.valueOf(0), Integer.valueOf(hbs_));
          StringBuffer sql_ = (new StringBuffer("select * from ")).append(wjtable).append(" where zhuangTai not in (3,4) ").append(" and guanLianBiaoShi=").append(oldhbs);
          System.out.println("========盒或卷里的文件sql==" + sql_);
          addWenjian(fileds, sql_.toString(), null, wjps, fjps, Integer.valueOf(hbs_), wjtable);
          System.out.println("========添加盒或卷里的文件==");
          this.hbs = Integer.valueOf(this.hbs.intValue() + 4);
          heps.addBatch();
          if ((this.count = Integer.valueOf(this.count.intValue() + 1)).intValue() % this.batchSize.intValue() == 0)
            heps.executeBatch(); 
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  private void addWenjian(String fileds, String sql, List<Map<String, Object>> wjlist, PreparedStatement wjps, PreparedStatement fjps, Integer newhbs, String wjtable) {
    try {
      System.out.println("========获取文件记录==");
      List<Map<String, Object>> list = new ArrayList<>();
      if (newhbs.intValue() == 0) {
        list = wjlist;
      } else {
        list = getListByMap(sql);
      } 
      if (list != null && list.size() > 0) {
        int num = list.size();
        System.out.println("========获取文件记录总数==" + num);
        if (newhbs.intValue() != 0)
          this.wjlsit.add(newhbs); 
        for (int i = 0; i < num; i++) {
          Map<String, Object> map = list.get(i);
          Object oldhbs = map.get("hangBiaoShi");
          if (!"MYSQL".equals(dataType))
            oldhbs = map.get("HANGBIAOSHI"); 
          if (newhbs.intValue() == 0)
            this.wjlsit.add(oldhbs); 
          int wjhbs_ = this.wjhbs.intValue();
          info(map, fileds, wjps, newhbs, Integer.valueOf(1), Integer.valueOf(wjhbs_));
          StringBuffer sql_ = (new StringBuffer("select * from ")).append(wjtable).append("FuJian where ").append(" guanLianBiaoShi=").append(oldhbs);
          boolean re = addFujian(fileds, sql_.toString(), fjps, Integer.valueOf(wjhbs_));
          if (re)
            this.fjlsit.add(oldhbs); 
          wjps.addBatch();
          this.wjhbs = Integer.valueOf(this.wjhbs.intValue() + 4);
          if ((this.wjcount = Integer.valueOf(this.wjcount.intValue() + 1)).intValue() % this.batchSize.intValue() == 0)
            wjps.executeBatch(); 
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  private boolean addFujian(String fileds, String sql, PreparedStatement fjps, Integer newhbs) {
    boolean result = false;
    try {
      List<Map<String, Object>> list = getListByMap(sql);
      if (list != null && list.size() > 0) {
        result = true;
        int num = list.size();
        for (int i = 0; i < num; i++) {
          Map<String, Object> map = list.get(i);
          int fjhbs_ = this.fjhbs.intValue();
          info(map, fileds, fjps, newhbs, Integer.valueOf(2), Integer.valueOf(fjhbs_));
          fjps.addBatch();
          this.fjhbs = Integer.valueOf(this.fjhbs.intValue() + 4);
          if ((this.fjcount = Integer.valueOf(this.fjcount.intValue() + 1)).intValue() % this.batchSize.intValue() == 0)
            fjps.executeBatch(); 
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return result;
  }
  
  private Connection getShuJuYuan(String qzh) {
    Connection connection = null;
    List<Map<String, String>> zzk = this.zongZhuanKuDao.getListToMap("select shujukulianjiedizhi,yonghuming,mima from T_SHUJUYUAN  where quanzonghao='" + qzh + "'", true);
    if (zzk != null && zzk.size() == 1) {
      Map<String, String> zzk_ = zzk.get(0);
      String url = zzk_.get("shujukulianjiedizhi");
      String driver = "com.mysql.jdbc.Driver";
      String name = zzk_.get("yonghuming");
      String pwd = zzk_.get("mima");
      if (!"MYSQL".equals(dataType)) {
        url = zzk_.get("shujukulianjiedizhi".toUpperCase());
        driver = "oracle.jdbc.driver.OracleDriver";
        name = zzk_.get("yonghuming".toUpperCase());
        pwd = zzk_.get("mima".toUpperCase());
      } 
      connection = CommStatic.getConnection_(driver, url, name, pwd);
    } 
    return connection;
  }
  
  private String formatSQL(String fileds, int type, String tb) {
    String table_ = tb;
    if (type == 2)
      table_ = String.valueOf(tb) + "FuJian"; 
    StringBuffer insertSQL = (new StringBuffer("insert into ")).append(table_).append(" (");
    String[] strs = fileds.split(";");
    String f_ = strs[type].replaceAll("-data", "");
    String kv = "";
    String[] strss = f_.split(",");
    for (int f = 0; f < strss.length; f++) {
      if ("".equals(kv)) {
        kv = "?";
      } else {
        kv = String.valueOf(kv) + ",?";
      } 
    } 
    insertSQL.append(f_).append(") values (").append(kv).append(")");
    System.out.println("插入语句========" + insertSQL.toString());
    return insertSQL.toString();
  }
  
  private String fenXiFiles(JSONObject jsonObject) {
    StringBuffer sqlWhere = new StringBuffer();
    Iterator<String> iterator = jsonObject.keys();
    String querySt = jsonObject.getString("querystr");
    String zuHeType = jsonObject.getString("zuHeType");
    if (StringUtils.isNotBlank(querySt)) {
      sqlWhere.append(CommStatic.zhuHeQueryJieXi_new(querySt, zuHeType, getDataType()));
    } else {
      while (iterator.hasNext()) {
        String key = iterator.next();
        String value = jsonObject.getString(key);
        if (value != null && !value.trim().equals("") && !value.equals("undefined") && !key.equals("table") && !key.equals("server") && !key.equals("filed") && !key.equals("querystr") && 
          !key.equals("zuHeType") && !key.equals("checkbox") && !key.equals("nd") && !key.equals("type") && !key.equals("leiXing")) {
          if (key.contains("begin")) {
            key = key.substring(0, key.indexOf("begin"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (key.contains("end")) {
            key = key.substring(0, key.indexOf("end"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (key.contains("like")) {
            key = key.substring(0, key.indexOf("like"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value.trim() + "%'");
            continue;
          } 
          if (key.contains("quanZongHao")) {
            if (StringUtils.isNotBlank(value)) {
              String checkbox = jsonObject.getString("checkbox");
              if ("true".equals(checkbox)) {
                String all_qz = jsonObject.getString("all_qz");
                sqlWhere.append(" and ").append(key).append(" in('").append(all_qz).append("')");
                continue;
              } 
              sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'");
            } 
            continue;
          } 
          if (key.equals("gdzt")) {
            if (value.equals("1")) {
              sqlWhere.append(" and zhuangTai =").append(value);
              continue;
            } 
            if (value.equals("2")) {
              sqlWhere.append(" and zhuangTai in(").append("0,2)");
              continue;
            } 
            if (value.equals("5"))
              sqlWhere.append(" and zhuangTai =").append(value); 
            continue;
          } 
          if (key.equals("guiDangLeiXing")) {
            if (value.equals("2")) {
              sqlWhere.append(" and guanLianBiaoShi =0");
              continue;
            } 
            if (value.equals("1"))
              sqlWhere.append(" and guanLianBiaoShi > 0"); 
            continue;
          } 
          if (key.equals("guiDangNianDu")) {
            String nd = jsonObject.getString("nd");
            if (StringUtils.isNotBlank(nd)) {
              sqlWhere.append(" and ").append(key).append(" ").append(nd).append("'").append(value).append("'");
              continue;
            } 
            sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'");
            continue;
          } 
          if (key.equals("hangBiaoShi")) {
            sqlWhere.append(" and ").append(key).append(" in (").append(value).append(")");
            continue;
          } 
          if (key.equals("all_qz")) {
            sqlWhere.append(" and quanZongHao ").append(" in (").append(value).append(")");
            continue;
          } 
          sqlWhere.append(" and ").append(key).append(" = '").append(value).append("'");
        } 
      } 
    } 
    return sqlWhere.toString();
  }
  
  public List getListByMap(String sql) {
    List<Map<Object, Object>> resultList = null;
    Statement stat = null;
    ResultSet rs = null;
    ResultSetMetaData data = null;
    int coloumCount = 0;
    String[] coloumNames = (String[])null;
    try {
      stat = this.bdkconn.createStatement();
      rs = stat.executeQuery(sql);
      data = rs.getMetaData();
      coloumCount = data.getColumnCount();
      coloumNames = new String[coloumCount];
      for (int i = 0; i < coloumCount; i++)
        coloumNames[i] = data.getColumnName(i + 1); 
      resultList = new ArrayList();
      while (rs.next()) {
        Map<Object, Object> map = new HashMap<>();
        for (int j = 0; j < coloumCount; j++)
          map.put(coloumNames[j], rs.getObject(coloumNames[j])); 
        resultList.add(map);
      } 
      if (rs != null)
        rs.close(); 
      stat.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
    if (resultList != null && resultList.size() == 0)
      resultList = null; 
    return resultList;
  }
  
  public List<Map> getListByMap(String sql, Object[] params) {
    List<Map> resultList = null;
    PreparedStatement stat = null;
    ResultSet rs = null;
    ResultSetMetaData data = null;
    int coloumCount = 0;
    String[] coloumNames = (String[])null;
    try {
      stat = this.bdkconn.prepareStatement(sql);
      int i;
      for (i = 0; i < params.length; i++)
        stat.setObject(i + 1, params[i]); 
      rs = stat.executeQuery();
      data = rs.getMetaData();
      coloumCount = data.getColumnCount();
      coloumNames = new String[coloumCount];
      for (i = 0; i < coloumCount; i++)
        coloumNames[i] = data.getColumnName(i + 1); 
      resultList = new ArrayList<>();
      while (rs.next()) {
        Map<Object, Object> map = new HashMap<>();
        for (int j = 0; j < coloumCount; j++)
          map.put(coloumNames[j], rs.getObject(coloumNames[j])); 
        resultList.add(map);
      } 
      if (rs != null)
        rs.close(); 
      stat.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } 
    if (resultList != null && resultList.size() == 0)
      resultList = null; 
    return resultList;
  }
}
